diff -urN gcc-3.3.3.orig/gcc/fold-const.c gcc-3.3.3/gcc/fold-const.c
--- gcc-3.3.3.orig/gcc/fold-const.c	2003-12-31 21:44:53.000000000 -0700
+++ gcc-3.3.3/gcc/fold-const.c	2004-04-20 02:28:59.000000000 -0600
@@ -6013,150 +6013,68 @@
 	    return fold (build (code, type, TREE_OPERAND (arg0, 0), tem));
 	}
 
-      /* Convert foo++ == CONST into ++foo == CONST + INCR.
-	 First, see if one arg is constant; find the constant arg
-	 and the other one.  */
-      {
-	tree constop = 0, varop = NULL_TREE;
-	int constopnum = -1;
 
-	if (TREE_CONSTANT (arg1))
-	  constopnum = 1, constop = arg1, varop = arg0;
-	if (TREE_CONSTANT (arg0))
-	  constopnum = 0, constop = arg0, varop = arg1;
+      /* Convert foo++ == CONST into ++foo == CONST + INCR.  */
+      if (TREE_CONSTANT (arg1)
+	  && (TREE_CODE (arg0) == POSTINCREMENT_EXPR
+	      || TREE_CODE (arg0) == POSTDECREMENT_EXPR)
+	  /* This optimization is invalid for ordered comparisons
+	     if CONST+INCR overflows or if foo+incr might overflow.
+	     This optimization is invalid for floating point due to rounding.
+	     For pointer types we assume overflow doesn't happen.  */
+	  && (POINTER_TYPE_P (TREE_TYPE (arg0))
+	      || (INTEGRAL_TYPE_P (TREE_TYPE (arg0))
+		  && (code == EQ_EXPR || code == NE_EXPR))))
+	{
+	  tree varop, newconst;
 
-	if (constop && TREE_CODE (varop) == POSTINCREMENT_EXPR)
-	  {
-	    /* This optimization is invalid for ordered comparisons
-	       if CONST+INCR overflows or if foo+incr might overflow.
-	       This optimization is invalid for floating point due to rounding.
-	       For pointer types we assume overflow doesn't happen.  */
-	    if (POINTER_TYPE_P (TREE_TYPE (varop))
-		|| (! FLOAT_TYPE_P (TREE_TYPE (varop))
-		    && (code == EQ_EXPR || code == NE_EXPR)))
-	      {
-		tree newconst
-		  = fold (build (PLUS_EXPR, TREE_TYPE (varop),
-				 constop, TREE_OPERAND (varop, 1)));
-
-		/* Do not overwrite the current varop to be a preincrement,
-		   create a new node so that we won't confuse our caller who
-		   might create trees and throw them away, reusing the
-		   arguments that they passed to build.  This shows up in
-		   the THEN or ELSE parts of ?: being postincrements.  */
-		varop = build (PREINCREMENT_EXPR, TREE_TYPE (varop),
-			       TREE_OPERAND (varop, 0),
-			       TREE_OPERAND (varop, 1));
-
-		/* If VAROP is a reference to a bitfield, we must mask
-		   the constant by the width of the field.  */
-		if (TREE_CODE (TREE_OPERAND (varop, 0)) == COMPONENT_REF
-		    && DECL_BIT_FIELD(TREE_OPERAND
-				      (TREE_OPERAND (varop, 0), 1)))
-		  {
-		    int size
-		      = TREE_INT_CST_LOW (DECL_SIZE
-					  (TREE_OPERAND
-					   (TREE_OPERAND (varop, 0), 1)));
-		    tree mask, unsigned_type;
-		    unsigned int precision;
-		    tree folded_compare;
-
-		    /* First check whether the comparison would come out
-		       always the same.  If we don't do that we would
-		       change the meaning with the masking.  */
-		    if (constopnum == 0)
-		      folded_compare = fold (build (code, type, constop,
-						    TREE_OPERAND (varop, 0)));
-		    else
-		      folded_compare = fold (build (code, type,
-						    TREE_OPERAND (varop, 0),
-						    constop));
-		    if (integer_zerop (folded_compare)
-			|| integer_onep (folded_compare))
-		      return omit_one_operand (type, folded_compare, varop);
-
-		    unsigned_type = (*lang_hooks.types.type_for_size)(size, 1);
-		    precision = TYPE_PRECISION (unsigned_type);
-		    mask = build_int_2 (~0, ~0);
-		    TREE_TYPE (mask) = unsigned_type;
-		    force_fit_type (mask, 0);
-		    mask = const_binop (RSHIFT_EXPR, mask,
-					size_int (precision - size), 0);
-		    newconst = fold (build (BIT_AND_EXPR,
-					    TREE_TYPE (varop), newconst,
-					    convert (TREE_TYPE (varop),
-						     mask)));
-		  }
+	  if (TREE_CODE (arg0) == POSTINCREMENT_EXPR)
+	    {
+	      newconst = fold (build (PLUS_EXPR, TREE_TYPE (arg0),
+				      arg1, TREE_OPERAND (arg0, 1)));
+	      varop = build (PREINCREMENT_EXPR, TREE_TYPE (arg0),
+			     TREE_OPERAND (arg0, 0),
+			     TREE_OPERAND (arg0, 1));
+	    }
+	  else
+	    {
+	      newconst = fold (build (MINUS_EXPR, TREE_TYPE (arg0),
+				      arg1, TREE_OPERAND (arg0, 1)));
+	      varop = build (PREDECREMENT_EXPR, TREE_TYPE (arg0),
+			     TREE_OPERAND (arg0, 0),
+			     TREE_OPERAND (arg0, 1));
+	    }
 
-		t = build (code, type,
-			   (constopnum == 0) ? newconst : varop,
-			   (constopnum == 1) ? newconst : varop);
-		return t;
-	      }
-	  }
-	else if (constop && TREE_CODE (varop) == POSTDECREMENT_EXPR)
-	  {
-	    if (POINTER_TYPE_P (TREE_TYPE (varop))
-		|| (! FLOAT_TYPE_P (TREE_TYPE (varop))
-		    && (code == EQ_EXPR || code == NE_EXPR)))
-	      {
-		tree newconst
-		  = fold (build (MINUS_EXPR, TREE_TYPE (varop),
-				 constop, TREE_OPERAND (varop, 1)));
-
-		/* Do not overwrite the current varop to be a predecrement,
-		   create a new node so that we won't confuse our caller who
-		   might create trees and throw them away, reusing the
-		   arguments that they passed to build.  This shows up in
-		   the THEN or ELSE parts of ?: being postdecrements.  */
-		varop = build (PREDECREMENT_EXPR, TREE_TYPE (varop),
-			       TREE_OPERAND (varop, 0),
-			       TREE_OPERAND (varop, 1));
-
-		if (TREE_CODE (TREE_OPERAND (varop, 0)) == COMPONENT_REF
-		    && DECL_BIT_FIELD(TREE_OPERAND
-				      (TREE_OPERAND (varop, 0), 1)))
-		  {
-		    int size
-		      = TREE_INT_CST_LOW (DECL_SIZE
-					  (TREE_OPERAND
-					   (TREE_OPERAND (varop, 0), 1)));
-		    tree mask, unsigned_type;
-		    unsigned int precision;
-		    tree folded_compare;
-
-		    if (constopnum == 0)
-		      folded_compare = fold (build (code, type, constop,
-						    TREE_OPERAND (varop, 0)));
-		    else
-		      folded_compare = fold (build (code, type,
-						    TREE_OPERAND (varop, 0),
-						    constop));
-		    if (integer_zerop (folded_compare)
-			|| integer_onep (folded_compare))
-		      return omit_one_operand (type, folded_compare, varop);
-
-		    unsigned_type = (*lang_hooks.types.type_for_size)(size, 1);
-		    precision = TYPE_PRECISION (unsigned_type);
-		    mask = build_int_2 (~0, ~0);
-		    TREE_TYPE (mask) = TREE_TYPE (varop);
-		    force_fit_type (mask, 0);
-		    mask = const_binop (RSHIFT_EXPR, mask,
-					size_int (precision - size), 0);
-		    newconst = fold (build (BIT_AND_EXPR,
-					    TREE_TYPE (varop), newconst,
-					    convert (TREE_TYPE (varop),
-						     mask)));
-		  }
 
-		t = build (code, type,
-			   (constopnum == 0) ? newconst : varop,
-			   (constopnum == 1) ? newconst : varop);
-		return t;
-	      }
-	  }
-      }
+	  /* If VAROP is a reference to a bitfield, we must mask
+	     the constant by the width of the field.  */
+	  if (TREE_CODE (TREE_OPERAND (varop, 0)) == COMPONENT_REF
+	      && DECL_BIT_FIELD (TREE_OPERAND (TREE_OPERAND (varop, 0), 1)))
+	    {
+	      tree fielddecl = TREE_OPERAND (TREE_OPERAND (varop, 0), 1);
+	      int size = TREE_INT_CST_LOW (DECL_SIZE (fielddecl));
+	      tree folded_compare, shift;
+
+	      /* First check whether the comparison would come out
+		 always the same.  If we don't do that we would
+		 change the meaning with the masking.  */
+	      folded_compare = fold (build (code, type,
+					    TREE_OPERAND (varop, 0),
+					    arg1));
+	      if (integer_zerop (folded_compare)
+		  || integer_onep (folded_compare))
+		return omit_one_operand (type, folded_compare, varop);
+
+	      shift = build_int_2 (TYPE_PRECISION (TREE_TYPE (varop)) - size,
+				   0);
+	      newconst = fold (build (LSHIFT_EXPR, TREE_TYPE (varop),
+				      newconst, shift));
+	      newconst = fold (build (RSHIFT_EXPR, TREE_TYPE (varop),
+				      newconst, shift));
+	    }
+
+	  return fold (build (code, type, varop, newconst));
+	}
 
       /* Change X >= C to X > (C - 1) and X < C to X <= (C - 1) if C > 0.
 	 This transformation affects the cases which are handled in later
diff -urN gcc-3.3.3.orig/gcc/function.c gcc-3.3.3/gcc/function.c
--- gcc-3.3.3.orig/gcc/function.c	2003-12-11 00:57:55.000000000 -0700
+++ gcc-3.3.3/gcc/function.c	2004-04-20 02:28:59.000000000 -0600
@@ -1499,7 +1499,11 @@
     regno = REGNO (reg);
 
   if (regno < func->x_max_parm_reg)
-    new = func->x_parm_reg_stack_loc[regno];
+    {
+      if (!func->x_parm_reg_stack_loc)
+	abort ();
+      new = func->x_parm_reg_stack_loc[regno];
+    }
 
   if (new == 0)
     new = assign_stack_local_1 (decl_mode, GET_MODE_SIZE (decl_mode), 0, func);
@@ -6961,6 +6965,14 @@
   clear_pending_stack_adjust ();
   do_pending_stack_adjust ();
 
+  /* ???  This is a kludge.  We want to ensure that instructions that
+     may trap are not moved into the epilogue by scheduling, because
+     we don't always emit unwind information for the epilogue.
+     However, not all machine descriptions define a blockage insn, so
+     emit an ASM_INPUT to act as one.  */
+  if (flag_non_call_exceptions)
+    emit_insn (gen_rtx_ASM_INPUT (VOIDmode, ""));
+
   /* Mark the end of the function body.
      If control reaches this insn, the function can drop through
      without returning a value.  */
diff -urN gcc-3.3.3.orig/gcc/gcc.c gcc-3.3.3/gcc/gcc.c
--- gcc-3.3.3.orig/gcc/gcc.c	2003-12-05 20:53:02.000000000 -0700
+++ gcc-3.3.3/gcc/gcc.c	2004-04-20 02:28:59.000000000 -0600
@@ -328,7 +328,7 @@
 static void add_preprocessor_option	PARAMS ((const char *, int));
 static void add_assembler_option	PARAMS ((const char *, int));
 static void add_linker_option		PARAMS ((const char *, int));
-static void process_command		PARAMS ((int, const char *const *));
+static void process_command		PARAMS ((int, const char **));
 static int execute			PARAMS ((void));
 static void alloc_args			PARAMS ((void));
 static void clear_args			PARAMS ((void));
@@ -732,7 +732,7 @@
 static const char *cc1_options =
 "%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  %1 %{!Q:-quiet} -dumpbase %B %{d*} %{m*} %{a*}\
- -auxbase%{c|S:%{o*:-strip %*}%{!o*: %b}}%{!c:%{!S: %b}}\
+ %{c|S:%{o*:-auxbase-strip %*}%{!o*:-auxbase %b}}%{!c:%{!S:-auxbase %b}}\
  %{g*} %{O*} %{W*&pedantic*} %{w} %{std*} %{ansi}\
  %{v:-version} %{pg:-p} %{p} %{f*} %{undef}\
  %{Qn:-fno-ident} %{--help:--help}\
@@ -1468,6 +1468,12 @@
 
   buf = concat ("%{static|static-libgcc:", static_name, " ", eh_name,
 		"}%{!static:%{!static-libgcc:",
+#ifdef HAVE_LD_AS_NEEDED
+		"%{!shared-libgcc:", static_name,
+		" --as-needed ", shared_name, " --no-as-needed}"
+		"%{shared-libgcc:", shared_name, "%{!shared: ", static_name,
+		"}",
+#else
 		"%{!shared:%{!shared-libgcc:", static_name, " ",
 		eh_name, "}%{shared-libgcc:", shared_name, " ",
 		static_name, "}}%{shared:",
@@ -1477,6 +1483,7 @@
 #else
 		shared_name,
 #endif
+#endif
 		"}}}", NULL);
 
   obstack_grow (obstack, buf, strlen (buf));
@@ -3050,7 +3057,7 @@
 static void
 process_command (argc, argv)
      int argc;
-     const char *const *argv;
+     const char **argv;
 {
   int i;
   const char *temp;
@@ -3279,10 +3286,10 @@
     }
 
   /* Convert new-style -- options to old-style.  */
-  translate_options (&argc, &argv);
+  translate_options (&argc, (const char *const **) &argv);
 
   /* Do language-specific adjustment/addition of flags.  */
-  lang_specific_driver (&argc, &argv, &added_libraries);
+  lang_specific_driver (&argc, (const char *const **) &argv, &added_libraries);
 
   /* Scan argv twice.  Here, the first time, just count how many switches
      there will be in their vector, and how many input files in theirs.
@@ -5917,12 +5924,12 @@
   kill (getpid (), signum);
 }
 
-extern int main PARAMS ((int, const char *const *));
+extern int main PARAMS ((int, const char **));
 
 int
 main (argc, argv)
      int argc;
-     const char *const *argv;
+     const char **argv;
 {
   size_t i;
   int value;
diff -urN gcc-3.3.3.orig/gcc/hooks.c gcc-3.3.3/gcc/hooks.c
--- gcc-3.3.3.orig/gcc/hooks.c	2002-12-09 16:53:58.000000000 -0700
+++ gcc-3.3.3/gcc/hooks.c	2004-04-20 02:28:59.000000000 -0600
@@ -1,5 +1,5 @@
 /* General-purpose hooks.
-   Copyright (C) 2002 Free Software Foundation, Inc.
+   Copyright (C) 2002, 2004 Free Software Foundation, Inc.
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
@@ -121,3 +121,11 @@
 {
   return false;
 }
+
+bool
+hook_bool_uintp_uintp_false (a, b)
+     unsigned int *a ATTRIBUTE_UNUSED;
+     unsigned int *b ATTRIBUTE_UNUSED;
+{
+  return false;
+}
diff -urN gcc-3.3.3.orig/gcc/hooks.h gcc-3.3.3/gcc/hooks.h
--- gcc-3.3.3.orig/gcc/hooks.h	2002-12-09 16:53:58.000000000 -0700
+++ gcc-3.3.3/gcc/hooks.h	2004-04-20 02:28:59.000000000 -0600
@@ -1,5 +1,5 @@
 /* General-purpose hooks.
-   Copyright (C) 2002 Free Software Foundation, Inc.
+   Copyright (C) 2002, 2004 Free Software Foundation, Inc.
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
@@ -29,6 +29,7 @@
 bool hook_bool_tree_hwi_hwi_tree_true
   PARAMS ((tree, HOST_WIDE_INT, HOST_WIDE_INT, tree));
 bool hook_bool_rtx_false PARAMS ((rtx));
+bool hook_bool_uintp_uintp_false PARAMS ((unsigned int *, unsigned int *));
 
 void hook_void_tree_int PARAMS ((tree, int));
 void hook_void_void PARAMS ((void));
diff -urN gcc-3.3.3.orig/gcc/intl.c gcc-3.3.3/gcc/intl.c
--- gcc-3.3.3.orig/gcc/intl.c	2002-01-08 12:03:18.000000000 -0700
+++ gcc-3.3.3/gcc/intl.c	2004-04-20 02:29:00.000000000 -0600
@@ -39,8 +39,8 @@
   setlocale (LC_ALL, "");
 #endif
 
-  (void) bindtextdomain ("gcc", LOCALEDIR);
-  (void) textdomain ("gcc");
+  (void) bindtextdomain (PACKAGE, LOCALEDIR);
+  (void) textdomain (PACKAGE);
 }
 
 #endif
diff -urN gcc-3.3.3.orig/gcc/java/ChangeLog gcc-3.3.3/gcc/java/ChangeLog
--- gcc-3.3.3.orig/gcc/java/ChangeLog	2004-02-14 13:18:46.000000000 -0700
+++ gcc-3.3.3/gcc/java/ChangeLog	2004-04-20 02:29:00.000000000 -0600
@@ -1,3 +1,9 @@
+2004-02-26  Andrew Haley  <aph@redhat.com>
+
+	PR java/12890:
+	* parse.y (do_resolve_class): Check return value from
+	breakdown_qualified().
+
 2004-02-14  Release Manager
 
 	* GCC 3.3.3 Released.
diff -urN gcc-3.3.3.orig/gcc/java/Make-lang.in gcc-3.3.3/gcc/java/Make-lang.in
--- gcc-3.3.3.orig/gcc/java/Make-lang.in	2003-07-08 07:28:41.000000000 -0600
+++ gcc-3.3.3/gcc/java/Make-lang.in	2004-04-20 02:29:00.000000000 -0600
@@ -154,7 +154,7 @@
 java.start.encap: $(GCJ)$(exeext)
 java.rest.encap:
 
-java.info: $(srcdir)/java/gcj.info
+java.info: $(srcdir)/java/gcj$(iv).info
 java.dvi: java/gcj.dvi
 java.generated-manpages: $(srcdir)/java/gcj.1 $(srcdir)/java/gcjh.1 \
 	$(srcdir)/java/jv-scan.1 $(srcdir)/java/jcf-dump.1 \
@@ -207,18 +207,18 @@
 
 java.install-info: installdirs
 	if [ -f jc1$(exeext) ] ; then \
-	  if [ -f $(srcdir)/java/gcj.info ]; then \
-	    rm -f $(DESTDIR)$(infodir)/gcj.info*; \
-	    for f in $(srcdir)/java/gcj.info*; do \
+	  if [ -f $(srcdir)/java/gcj$(iv).info ]; then \
+	    rm -f $(DESTDIR)$(infodir)/gcj$(iv).info*; \
+	    for f in $(srcdir)/java/gcj$(iv).info*; do \
 	      realfile=`echo $$f | sed -e 's|.*/\([^/]*\)$$|\1|'`; \
 	      $(INSTALL_DATA) $$f $(DESTDIR)$(infodir)/$$realfile; \
 	    done; \
-	    chmod a-x $(DESTDIR)$(infodir)/gcj.info*; \
+	    chmod a-x $(DESTDIR)$(infodir)/gcj$(iv).info*; \
 	  else true; fi; \
 	else true; fi
-	-if [ -f jc1$(exeext) ] && [ -f $(DESTDIR)$(infodir)/gcj.info ]; then \
+	-if [ -f jc1$(exeext) ] && [ -f $(DESTDIR)$(infodir)/gcj$(iv).info ]; then \
 	  if $(SHELL) -c 'install-info --version' >/dev/null 2>&1; then \
-	    install-info --dir-file=$(DESTDIR)$(infodir)/dir $(DESTDIR)$(infodir)/gcj.info; \
+	    install-info --dir-file=$(DESTDIR)$(infodir)/dir $(DESTDIR)$(infodir)/gcj$(iv).info; \
 	  else true; fi; \
 	else true; fi
 
@@ -338,12 +338,12 @@
 	  $(srcdir)/java/jcf-path.c $(OUTPUT_OPTION)
 
 # Documentation
-$(srcdir)/java/gcj.info: $(srcdir)/java/gcj.texi \
+$(srcdir)/java/gcj$(iv).info: $(srcdir)/java/gcj.texi \
 	 $(srcdir)/doc/include/fdl.texi $(srcdir)/doc/include/gpl.texi \
 	 $(srcdir)/doc/include/gcc-common.texi
 	if test "x$(BUILD_INFO)" = xinfo; then \
-	  rm -f $(srcdir)/java/gcc.info*; \
-	  cd $(srcdir)/java && $(MAKEINFO) -I../doc/include -o gcj.info gcj.texi; \
+	  rm -f $(srcdir)/java/gcj$(iv).info*; \
+	  cd $(srcdir)/java && $(MAKEINFO) $(MAKEINFOFLAGS) $(MAKEINFODEFS) -I../doc/include -o gcj$(iv).info gcj.texi; \
 	else true; fi
 
 java/gcj.dvi: $(srcdir)/java/gcj.texi $(srcdir)/doc/include/fdl.texi \
diff -urN gcc-3.3.3.orig/gcc/java/parse.y gcc-3.3.3/gcc/java/parse.y
--- gcc-3.3.3.orig/gcc/java/parse.y	2003-05-02 18:36:56.000000000 -0600
+++ gcc-3.3.3/gcc/java/parse.y	2004-04-20 02:29:00.000000000 -0600
@@ -5797,14 +5797,16 @@
 	 class and then treat Id as a member type.  If we can't find Q
 	 as a class then we fall through.  */
       tree q, left, left_type, right;
-      breakdown_qualified (&left, &right, TYPE_NAME (class_type));
-      BUILD_PTR_FROM_NAME (left_type, left);
-      q = do_resolve_class (enclosing, left_type, decl, cl);
-      if (q)
-	{
-	  enclosing = q;
-	  saved_enclosing_type = TREE_TYPE (q);
-	  BUILD_PTR_FROM_NAME (class_type, right);
+      if (breakdown_qualified (&left, &right, TYPE_NAME (class_type)) == 0)
+	{
+	  BUILD_PTR_FROM_NAME (left_type, left);
+	  q = do_resolve_class (enclosing, left_type, decl, cl);
+	  if (q)
+	    {
+	      enclosing = q;
+	      saved_enclosing_type = TREE_TYPE (q);
+	      BUILD_PTR_FROM_NAME (class_type, right);
+	    }
 	}
     }
 
diff -urN gcc-3.3.3.orig/gcc/optabs.c gcc-3.3.3/gcc/optabs.c
--- gcc-3.3.3.orig/gcc/optabs.c	2003-07-18 18:25:25.000000000 -0600
+++ gcc-3.3.3/gcc/optabs.c	2004-04-20 02:28:59.000000000 -0600
@@ -3476,6 +3476,16 @@
       return;
     }
 
+  /* Don't allow operands to the compare to trap, as that can put the
+     compare and branch in different basic blocks.  */
+  if (flag_non_call_exceptions)
+    {
+      if (may_trap_p (x))
+	x = force_reg (mode, x);
+      if (may_trap_p (y))
+	y = force_reg (mode, y);
+    }
+
   *px = x;
   *py = y;
   if (can_compare_p (*pcomparison, mode, purpose))
diff -urN gcc-3.3.3.orig/gcc/reload.c gcc-3.3.3/gcc/reload.c
--- gcc-3.3.3.orig/gcc/reload.c	2004-01-23 09:43:43.000000000 -0700
+++ gcc-3.3.3/gcc/reload.c	2004-04-20 02:28:59.000000000 -0600
@@ -1,6 +1,6 @@
 /* Search an insn for pseudo regs that must be in hard regs and are not.
    Copyright (C) 1987, 1988, 1989, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
-   1999, 2000, 2001, 2002 Free Software Foundation, Inc.
+   1999, 2000, 2001, 2002, 2004 Free Software Foundation, Inc.
 
 This file is part of GCC.
 
@@ -2661,7 +2661,15 @@
 	      if (i == noperands - 1)
 		abort ();
 
-	      commutative = i;
+	      /* We currently only support one commutative pair of
+		 operands.  Some existing asm code currently uses more
+		 than one pair.  Previously, that would usually work,
+		 but sometimes it would crash the compiler.  We
+		 continue supporting that case as well as we can by
+		 silently ignoring all but the first pair.  In the
+		 future we may handle it correctly.  */
+	      if (commutative < 0)
+		commutative = i;
 	    }
 	  else if (ISDIGIT (c))
 	    {
@@ -3025,9 +3033,8 @@
 		break;
 
 	      case '%':
-		/* The last operand should not be marked commutative.  */
-		if (i != noperands - 1)
-		  commutative = i;
+		/* We only support one commutative marker, the first
+		   one.  We already set commutative above.  */
 		break;
 
 	      case '?':
diff -urN gcc-3.3.3.orig/gcc/reload1.c gcc-3.3.3/gcc/reload1.c
--- gcc-3.3.3.orig/gcc/reload1.c	2003-12-01 01:18:38.000000000 -0700
+++ gcc-3.3.3/gcc/reload1.c	2004-04-20 02:28:59.000000000 -0600
@@ -789,8 +789,18 @@
 		     that is not a legitimate memory operand.  As later
 		     stages of reload assume that all addresses found
 		     in the reg_equiv_* arrays were originally legitimate,
-		     we ignore such REG_EQUIV notes.  */
-		  if (memory_operand (x, VOIDmode))
+		     we ignore such REG_EQUIV notes.
+
+		     It also can happen that a REG_EQUIV note contains a MEM
+		     that carries the /u flag, for example when GCSE turns
+		     the load of a constant into a move from a pseudo that
+		     already contains the constant and attaches a REG_EQUAL
+		     note to the insn, which is later promoted to REQ_EQUIV
+		     by local-alloc.  If the destination pseudo happens not
+		     to be assigned to a hard reg, it will be replaced by
+		     the MEM as the destination of the move, thus generating
+		     a store to a possibly read-only memory location.  */
+		  if (memory_operand (x, VOIDmode) && ! RTX_UNCHANGING_P (x))
 		    {
 		      /* Always unshare the equivalence, so we can
 			 substitute into this insn without touching the
@@ -4397,6 +4407,7 @@
       /* In use for anything means we can't use it for RELOAD_OTHER.  */
       if (TEST_HARD_REG_BIT (reload_reg_used_in_other_addr, regno)
 	  || TEST_HARD_REG_BIT (reload_reg_used_in_op_addr, regno)
+	  || TEST_HARD_REG_BIT (reload_reg_used_in_op_addr_reload, regno)
 	  || TEST_HARD_REG_BIT (reload_reg_used_in_insn, regno))
 	return 0;
 
@@ -4578,6 +4589,7 @@
 	  return 0;
 
       return (! TEST_HARD_REG_BIT (reload_reg_used_in_op_addr, regno)
+	      && ! TEST_HARD_REG_BIT (reload_reg_used_in_op_addr_reload, regno)
 	      && ! TEST_HARD_REG_BIT (reload_reg_used_in_insn, regno)
 	      && ! TEST_HARD_REG_BIT (reload_reg_used, regno));
 
@@ -8363,6 +8375,8 @@
     {
       cselib_val *v;
       struct elt_loc_list *l;
+      rtx op;
+      enum machine_mode mode;
 
       CLEAR_HARD_REG_SET (equiv_regs[i]);
 
@@ -8374,7 +8388,52 @@
 	      && recog_data.operand_mode[i] == VOIDmode))
 	continue;
 
-      v = cselib_lookup (recog_data.operand[i], recog_data.operand_mode[i], 0);
+      op = recog_data.operand[i];
+      mode = GET_MODE (op);
+#ifdef LOAD_EXTEND_OP
+      if (GET_CODE (op) == MEM
+	  && GET_MODE_BITSIZE (mode) < BITS_PER_WORD
+	  && LOAD_EXTEND_OP (mode) != NIL)
+	{
+	  rtx set = single_set (insn);
+
+	  /* We might have multiple sets, some of which do implict
+	     extension.  Punt on this for now.  */
+	  if (! set)
+	    continue;
+	  /* If the destination is a also MEM or a STRICT_LOW_PART, no
+	     extension applies.
+	     Also, if there is an explicit extension, we don't have to
+	     worry about an implicit one.  */
+	  else if (GET_CODE (SET_DEST (set)) == MEM
+		   || GET_CODE (SET_DEST (set)) == STRICT_LOW_PART
+		   || GET_CODE (SET_SRC (set)) == ZERO_EXTEND
+		   || GET_CODE (SET_SRC (set)) == SIGN_EXTEND)
+	    ; /* Continue ordinary processing.  */
+	  /* If this is a straight load, make the extension explicit.  */
+	  else if (GET_CODE (SET_DEST (set)) == REG
+		   && recog_data.n_operands == 2
+		   && SET_SRC (set) == op
+		   && SET_DEST (set) == recog_data.operand[1-i])
+	    {
+	      validate_change (insn, recog_data.operand_loc[i],
+			       gen_rtx_fmt_e (LOAD_EXTEND_OP (mode),
+					      word_mode, op),
+			       1);
+	      validate_change (insn, recog_data.operand_loc[1-i],
+			       gen_rtx_REG (word_mode, REGNO (SET_DEST (set))),
+			       1);
+	      if (!apply_change_group ())
+		return 0;
+	      return reload_cse_simplify_operands (insn, testreg);
+	    }
+	  else
+	    /* ??? There might be arithmetic operations with memory that are
+	       safe to optimize, but is it worth the trouble?  */
+	    continue;
+	}
+#endif /* LOAD_EXTEND_OP */
+      v = cselib_lookup (op, recog_data.operand_mode[i], 0);
       if (! v)
 	continue;
 
diff -urN gcc-3.3.3.orig/gcc/rtl.h gcc-3.3.3/gcc/rtl.h
--- gcc-3.3.3.orig/gcc/rtl.h	2003-05-01 19:21:07.000000000 -0600
+++ gcc-3.3.3/gcc/rtl.h	2004-04-20 02:29:00.000000000 -0600
@@ -1,6 +1,6 @@
 /* Register Transfer Language (RTL) definitions for GNU C-Compiler
    Copyright (C) 1987, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
-   1999, 2000, 2001, 2002 Free Software Foundation, Inc.
+   1999, 2000, 2001, 2002, 2004 Free Software Foundation, Inc.
 
 This file is part of GCC.
 
@@ -1428,7 +1428,6 @@
 
 /* In varasm.c  */
 extern rtx immed_double_const		PARAMS ((HOST_WIDE_INT, HOST_WIDE_INT, enum machine_mode));
-extern rtx mem_for_const_double		PARAMS ((rtx));
 extern rtx force_const_mem		PARAMS ((enum machine_mode, rtx));
 
 /* In varasm.c  */
@@ -1932,6 +1931,9 @@
 extern void cse_end_of_basic_block	PARAMS ((rtx,
 						struct cse_basic_block_data *,
 						int, int, int));
+extern void cse_condition_code_reg	PARAMS ((void));
+extern enum machine_mode default_cc_modes_compatible PARAMS ((enum machine_mode,
+							      enum machine_mode));
 
 /* In jump.c */
 extern int comparison_dominates_p	PARAMS ((enum rtx_code, enum rtx_code));
diff -urN gcc-3.3.3.orig/gcc/sched-ebb.c gcc-3.3.3/gcc/sched-ebb.c
--- gcc-3.3.3.orig/gcc/sched-ebb.c	2003-07-15 07:09:10.000000000 -0600
+++ gcc-3.3.3/gcc/sched-ebb.c	2004-04-20 02:28:59.000000000 -0600
@@ -1,6 +1,6 @@
 /* Instruction scheduling pass.
    Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998,
-   1999, 2000, 2001, 2002 Free Software Foundation, Inc.
+   1999, 2000, 2001, 2002, 2004 Free Software Foundation, Inc.
    Contributed by Michael Tiemann (tiemann@cygnus.com) Enhanced by,
    and currently maintained by, Jim Wilson (wilson@cygnus.com)
 
@@ -203,7 +203,7 @@
 
   NULL, NULL,
   NULL, NULL,
-  0, 1
+  0, 0
 };
 
 /* Schedule a single extended basic block, defined by the boundaries HEAD
diff -urN gcc-3.3.3.orig/gcc/target-def.h gcc-3.3.3/gcc/target-def.h
--- gcc-3.3.3.orig/gcc/target-def.h	2002-12-09 16:53:59.000000000 -0700
+++ gcc-3.3.3/gcc/target-def.h	2004-04-20 02:28:59.000000000 -0600
@@ -1,5 +1,5 @@
 /* Default initializers for a generic GCC target.
-   Copyright (C) 2001, 2002 Free Software Foundation, Inc.
+   Copyright (C) 2001, 2002, 2004 Free Software Foundation, Inc.
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
@@ -239,6 +239,9 @@
 #define TARGET_BINDS_LOCAL_P default_binds_local_p
 #endif
 
+/* In cse.c.  */
+#define TARGET_CC_MODES_COMPATIBLE default_cc_modes_compatible
+
 /* In hook.c.  */
 #define TARGET_CANNOT_MODIFY_JUMPS_P hook_bool_void_false
 #define TARGET_CANNOT_FORCE_CONST_MEM hook_bool_rtx_false
@@ -247,6 +250,7 @@
 #define TARGET_INSERT_ATTRIBUTES hook_void_tree_treeptr
 #define TARGET_FUNCTION_ATTRIBUTE_INLINABLE_P hook_bool_tree_false
 #define TARGET_MS_BITFIELD_LAYOUT_P hook_bool_tree_false
+#define TARGET_FIXED_CONDITION_CODE_REGS hook_bool_uintp_uintp_false
 
 #ifndef TARGET_IN_SMALL_DATA_P
 #define TARGET_IN_SMALL_DATA_P hook_bool_tree_false
@@ -278,6 +282,8 @@
   TARGET_BINDS_LOCAL_P,				\
   TARGET_ENCODE_SECTION_INFO,			\
   TARGET_STRIP_NAME_ENCODING,			\
+  TARGET_FIXED_CONDITION_CODE_REGS,		\
+  TARGET_CC_MODES_COMPATIBLE,			\
   TARGET_HAVE_NAMED_SECTIONS,			\
   TARGET_HAVE_CTORS_DTORS,			\
   TARGET_HAVE_TLS,				\
diff -urN gcc-3.3.3.orig/gcc/target.h gcc-3.3.3/gcc/target.h
--- gcc-3.3.3.orig/gcc/target.h	2002-12-09 16:53:59.000000000 -0700
+++ gcc-3.3.3/gcc/target.h	2004-04-20 02:28:59.000000000 -0600
@@ -1,5 +1,5 @@
 /* Data structure definitions for a generic GCC target.
-   Copyright (C) 2001, 2002 Free Software Foundation, Inc.
+   Copyright (C) 2001, 2002, 2004 Free Software Foundation, Inc.
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
@@ -279,6 +279,23 @@
   /* Undo the effects of encode_section_info on the symbol string.  */
   const char * (* strip_name_encoding) PARAMS ((const char *));
 
+  /* Fetch the fixed register(s) which hold condition codes, for
+     targets where it makes sense to look for duplicate assignments to
+     the condition codes.  This should return true if there is such a
+     register, false otherwise.  The arguments should be set to the
+     fixed register numbers.  Up to two condition code registers are
+     supported.  If there is only one for this target, the int pointed
+     at by the second argument should be set to -1.  */
+  bool (* fixed_condition_code_regs) PARAMS ((unsigned int *, unsigned int *));
+
+  /* If two condition code modes are compatible, return a condition
+     code mode which is compatible with both, such that a comparison
+     done in the returned mode will work for both of the original
+     modes.  If the condition code modes are not compatible, return
+     VOIDmode.  */
+  enum machine_mode (* cc_modes_compatible) PARAMS ((enum machine_mode,
+						     enum machine_mode));
+
   /* Leave the boolean fields at the end.  */
 
   /* True if arbitrary sections are supported.  */
diff -urN gcc-3.3.3.orig/gcc/testsuite/ChangeLog gcc-3.3.3/gcc/testsuite/ChangeLog
--- gcc-3.3.3.orig/gcc/testsuite/ChangeLog	2004-02-14 13:19:09.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/ChangeLog	2004-04-20 02:29:00.000000000 -0600
@@ -1,3 +1,83 @@
+2004-04-01  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c++/14755
+	* gcc.c-torture/execute/20040331-1.c: New test.
+
+2004-04-01  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c/14069
+	* gcc.dg/20040322-1.c: New test.
+
+	Backport from mainline:
+	2003-04-07  J"orn Rennecke  <joern.rennecke@superh.com>
+
+	* gcc.dg/noncompile/init-4.c: New test.
+
+2004-03-25  Eric Botcazou  <ebotcazou@libertysurf.fr>
+
+	* gcc.dg/20040127-1.c: New test.
+	* gcc.dg/20040127-2.c: New test.
+
+2004-03-21  Roger Sayle  <roger@eyesopen.com>
+	    Kazu Hirata  <kazu@cs.umass.edu>
+
+	* gcc.c-torture/execute/20040307-1.c: New test case.
+
+2004-03-21  Roger Sayle  <roger@eyesopen.com>
+
+	PR target/13889
+	* gcc.c-torture/compile/pr13889.c: New test case.
+
+2004-03-13  Eric Botcazou  <ebotcazou@libertysurf.fr>
+
+	PR middle-end/14470
+	* gcc.c-torture/execute/20040313-1.c: New test.
+
+2004-03-13  Jakub Jelinek  <jakub@redhat.com>
+
+	PR target/14533
+	* gcc.dg/20040311-2.c: New test.
+
+2004-03-10  Roger Sayle  <roger@eyesopen.com>
+
+	PR middle-end/14289
+	* gcc.dg/pr14289-1.c: New test case.
+	* gcc.dg/pr14289-2.c: Likewise.
+	* gcc.dg/pr14289-3.c: Likewise.
+
+2004-03-09  Giovanni Bajo  <giovannibajo@gcc.gnu.org>
+
+	PR c++/14409
+	* g++.dg/template/spec12.C: New test.
+
+2004-03-06  Ulrich Weigand  <uweigand@de.ibm.com>
+
+	* gcc.dg/20040306-1.c: New test.
+
+2004-02-25  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>
+
+	* g++.dg/opt/inline4.C (dg-final): Robustify regexp.
+	* g++.dg/opt/inline6.C (dg-final): Robustify regexp.
+
+2004-02-23  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>
+
+	PR c++/13635
+	* g++.dg/template/spec11.C: New test.
+
+2004-02-23  Giovanni Bajo  <giovannibajo@gcc.gnu.org>
+
+	PR c++/14250
+	* g++.dg/other/switch1.C: New test.
+
+2004-02-22  Jakub Jelinek  <jakub@redhat.com>
+
+	* g++.dg/parse/init1.C: New test.
+
+2004-02-22  Hans-Peter Nilsson  <hp@axis.com>
+
+	PR target/14209
+	* gcc.c-torture/execute/20040218-1.c: New test.
+
 2004-02-14  Release Manager
 
 	* GCC 3.3.3 Released.
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/conversion/op2.C gcc-3.3.3/gcc/testsuite/g++.dg/conversion/op2.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/conversion/op2.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/conversion/op2.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,14 @@
+// PR c++/13907
+
+struct A {
+  operator int & ();
+  operator const int & () const;
+};
+                                                                               
+void f(int &);
+void f(const int &);
+          
+int main() {
+  const A x = A();
+  f(x);
+}
